/************************************************************************************/
/*  Program name CAPAPEXT_INV_I.sql                                                 */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
set verify off;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPAPEXT_INV_I';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPAP_INV_I.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO			VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_B (p_NGO VARCHAR2) IS
	SELECT
		F.*,
		H.Batch_Name	Batch_Name,
		H.Batch_Date	Batch_Date,
		B.Name			OU_Name
	FROM
		AP_INVOICES_ALL				F,
		AP_BATCHES_ALL				H,
		HR_ALL_ORGANIZATION_UNITS	B,
		HR_ORGANIZATION_INFORMATION	I
	WHERE	SUBSTR(B.Name,4,4)			=	p_NGO
	AND		F.Batch_ID					=	H.Batch_ID --(+)
	AND		B.Organization_ID			=	F.Org_ID
	AND		B.Organization_ID			=	I.Organization_ID
	AND		I.Org_Information_Context	=	'Operating Unit Information'
	ORDER BY
		F.Batch_ID,
		F.Invoice_ID;

BEGIN
	lv_NGO		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_B(lv_NGO) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Invoice_ID||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
					C1.Last_Updated_By||CHR(9)||
					C1.Vendor_ID||CHR(9)||
				C1.Invoice_Num||CHR(9)||
					C1.Set_Of_Books_ID||CHR(9)||
				C1.Invoice_Currency_Code||CHR(9)||
				C1.Payment_Currency_Code||CHR(9)||
				C1.Payment_Cross_Rate||CHR(9)||
				C1.Invoice_Amount||CHR(9)||
					C1.Vendor_Site_ID||CHR(9)||
				C1.Amount_Paid||CHR(9)||
				C1.Discount_Amount_Taken||CHR(9)||
				C1.Invoice_Date||CHR(9)||
				C1.Source||CHR(9)||
				C1.Invoice_Type_Lookup_Code||CHR(9)||
				REPLACE(C1.Description,CHR(10),'^C10^')||CHR(9)||
					C1.Batch_ID||CHR(9)||
				C1.Amount_Applicable_To_Discount||CHR(9)||
				C1.Tax_Amount||CHR(9)||
					C1.Terms_ID||CHR(9)||
				C1.Terms_Date||CHR(9)||
				C1.Payment_Method_Lookup_Code||CHR(9)||
				C1.Pay_Group_Lookup_Code||CHR(9)||
				C1.ACCTS_Pay_Code_Combination_ID||CHR(9)||
				C1.Payment_Status_Flag||CHR(9)||
				C1.Creation_Date||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.Base_Amount||CHR(9)||
				C1.Vat_Code||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
				C1.Exclusive_Payment_Flag||CHR(9)||
				C1.PO_Header_ID||CHR(9)||					--	???
				C1.Freight_Amount||CHR(9)||
				C1.Goods_Received_Date||CHR(9)||
				C1.Invoice_Received_Date||CHR(9)||
				C1.Voucher_Num||CHR(9)||
				C1.Approved_Amount||CHR(9)||
				C1.Recurring_Payment_ID||CHR(9)||			--	???
				C1.Exchange_Rate||CHR(9)||
				C1.Exchange_Rate_Type||CHR(9)||
				C1.Exchange_Date||CHR(9)||
				C1.Earliest_Settlement_Date||CHR(9)||
				C1.Original_Prepayment_Amount||CHR(9)||
				C1.Doc_Sequence_ID||CHR(9)||				--	???
				C1.Doc_Sequence_Value||CHR(9)||
				C1.Doc_Category_Code||CHR(9)||
				C1.Attribute1||CHR(9)||
				C1.Attribute2||CHR(9)||
				C1.Attribute3||CHR(9)||
				C1.Attribute4||CHR(9)||
				C1.Attribute5||CHR(9)||
				C1.Attribute6||CHR(9)||
				C1.Attribute7||CHR(9)||
				C1.Attribute8||CHR(9)||
				C1.Attribute9||CHR(9)||
				C1.Attribute10||CHR(9)||
				C1.Attribute11||CHR(9)||
				C1.Attribute12||CHR(9)||
				C1.Attribute13||CHR(9)||
				C1.Attribute14||CHR(9)||
				C1.Attribute15||CHR(9)||
				C1.Attribute_Category||CHR(9)||
				C1.Approval_Status||CHR(9)||
				C1.Approval_Description||CHR(9)||
				C1.Invoice_Distribution_Total||CHR(9)||
				C1.Posting_Status||CHR(9)||
				C1.Prepay_Flag||CHR(9)||
					C1.Authorized_By||CHR(9)||
				C1.Cancelled_Date||CHR(9)||
					C1.Cancelled_By||CHR(9)||
				C1.Cancelled_Amount||CHR(9)||
				C1.Temp_Cancelled_Amount||CHR(9)||
				C1.Project_Accounting_Context||CHR(9)||
				C1.USSGL_Transaction_Code||CHR(9)||
				C1.USSGL_Trx_Code_Context||CHR(9)||
				C1.Project_ID||CHR(9)||						--	???
				C1.Task_ID||CHR(9)||						--	???
				C1.Expenditure_Type||CHR(9)||
				C1.Expenditure_Item_Date||CHR(9)||
				C1.PA_Quantity||CHR(9)||
				C1.Expenditure_Organization_ID||CHR(9)||	--	???
					C1.PA_Default_Dist_CCID||CHR(9)||		--	???
				C1.Vendor_Prepay_Amount||CHR(9)||
				C1.Payment_Amount_Total||CHR(9)||
				C1.AWT_Flag||CHR(9)||
				C1.AWT_Group_ID||CHR(9)||					--	???
				C1.Reference_1||CHR(9)||
				C1.Reference_2||CHR(9)||
					C1.Org_ID||CHR(9)||
				C1.Pre_Withholding_Amount||CHR(9)||
				C1.Global_Attribute_Category||CHR(9)||
				C1.Global_Attribute1||CHR(9)||
				C1.Global_Attribute2||CHR(9)||
				C1.Global_Attribute3||CHR(9)||
				C1.Global_Attribute4||CHR(9)||
				C1.Global_Attribute5||CHR(9)||
				C1.Global_Attribute6||CHR(9)||
				C1.Global_Attribute7||CHR(9)||
				C1.Global_Attribute8||CHR(9)||
				C1.Global_Attribute9||CHR(9)||
				C1.Global_Attribute10||CHR(9)||
				C1.Global_Attribute11||CHR(9)||
				C1.Global_Attribute12||CHR(9)||
				C1.Global_Attribute13||CHR(9)||
				C1.Global_Attribute14||CHR(9)||
				C1.Global_Attribute15||CHR(9)||
				C1.Global_Attribute16||CHR(9)||
				C1.Global_Attribute17||CHR(9)||
				C1.Global_Attribute18||CHR(9)||
				C1.Global_Attribute19||CHR(9)||
				C1.Global_Attribute20||CHR(9)||
				C1.Auto_Tax_Calc_Flag||CHR(9)||
				C1.Payment_Cross_Rate_Type||CHR(9)||
				C1.Payment_Cross_Rate_Date||CHR(9)||
				C1.Pay_Curr_Invoice_Amount||CHR(9)||
				C1.Mrc_Base_Amount||CHR(9)||
				C1.Mrc_Exchange_Rate||CHR(9)||
				C1.Mrc_Exchange_Rate_Type||CHR(9)||
				C1.Mrc_Exchange_Date||CHR(9)||
				C1.GL_Date||CHR(9)||
				C1.Award_ID||CHR(9)||							--	???
				C1.Paid_On_Behalf_Employee_ID||CHR(9)||			--	???
				C1.AMT_Due_Ccard_Company||CHR(9)||
				C1.AMT_Due_Employee||CHR(9)||
				C1.Approval_Ready_Flag||CHR(9)||
				C1.Approval_Iteration||CHR(9)||
				C1.WFApproval_Status||CHR(9)||
					C1.Requester_ID||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Last_Updated_By)||CHR(9)||
				CAPBREXT_COMMON.GetVendorName(C1.Vendor_ID)||CHR(9)||
				CAPBREXT_COMMON.GetVendorNum(C1.Vendor_ID)||CHR(9)||
				CAPBREXT_COMMON.GetSOBShortName(C1.Set_Of_Books_ID)||CHR(9)||
				CAPBREXT_COMMON.GetVendorSiteCode(C1.Vendor_ID,C1.Vendor_Site_ID)||CHR(9)||
				C1.Batch_Name||CHR(9)||
				C1.Batch_Date||CHR(9)||
				CAPBREXT_COMMON.GetAPTerm(C1.Terms_ID)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Created_By)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Authorized_By)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Cancelled_By)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.PA_Default_Dist_CCID)||CHR(9)||
				C1.OU_Name||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Requester_ID)
			);
			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;

END;
/